# include <stdio.h>
# include <stddef.h>
# include <locale.h>
# include <stdlib.h>
# define U(x) ((x)&0377)
# define NCH 256
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX 200

#ifdef __cplusplus
int yylook(void);
extern "C" int yywrap(void), yyless(int), yyreject(void);
#endif /* __cplusplus */

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
# include <iostream.h>
# define output(c) (*yyout) << ((unsigned char) c)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):yyin->get())==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define ECHO (*yyout) << yytext
istream *yyin = &cin;
ostream *yyout = &cout;
#else
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define ECHO fprintf(yyout, "%S",yywtext)
FILE *yyin = NULL, *yyout = NULL;
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define REJECT { yynstr = yyreject(); goto yyfussy;}
# define yysetlocale() setlocale(LC_ALL,"")
# define wreturn(r) return(yywreturn(r))
# define winput() yywinput()
# define wunput(c) yywunput(c)
# define woutput(c) yywoutput(c)
int yyleng;
extern char yytext[];
int yywleng; extern wchar_t yywtext[];
int yymorfg;
int yymbcurmax = -1;
int __once_yylex = 1;
extern unsigned char *yysptr, yysbuf[];
int yytchar;
extern int yylineno;
struct yywork;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/*
 * Copyright (c) 1997-1999 Erez Zadok
 * Copyright (c) 1989 Jan-Simon Pendry
 * Copyright (c) 1989 Imperial College of Science, Technology & Medicine
 * Copyright (c) 1989 The Regents of the University of California.
 * All rights reserved.
 *
 * This code is derived from software contributed to Berkeley by
 * Jan-Simon Pendry at Imperial College, London.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by the University of
 *      California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	%W% (Berkeley) %G%
 *
 * $Id: conf_tok.l,v 1.2 1999/01/10 21:53:45 ezk Exp $
 *
 */

/*
 * Lexical analyzer for AMD configuration parser.
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */
/*
 * Some systems include a definition for the macro ECHO in <sys/ioctl.h>,
 * and their (bad) version of lex defines it too at the very beginning of
 * the generated lex.yy.c file (before it can be easily undefined),
 * resulting in a conflict.  So undefine it here before needed.
 * Luckily, it does not appear that this macro is actually used in the rest
 * of the generated lex.yy.c file.
 */
#ifdef ECHO
# undef ECHO
#endif /* ECHO */
#include <am_defs.h>
#include <amd.h>
#include <conf_parse.h>
/* and once again undefine this, just in case */
#ifdef ECHO
# undef ECHO
#endif /* ECHO */

/*
 * There are some things that need to be defined only if using GNU flex.
 * These must not be defined if using standard lex
 */
#ifdef FLEX_SCANNER
# ifndef ECHO
#  define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
# endif /* not ECHO */
int yylineno = 0;
#endif /* FLEX_SCANNER */

int yylex(void);
/*
 * some systems such as DU-4.x have a different GNU flex in /usr/bin
 * which automatically generates yywrap macros and symbols.  So I must
 * distinguish between them and when yywrap is actually needed.
 */
#ifndef yywrap
int yywrap(void);
#endif /* not yywrap */

#define TOK_DEBUG 0

#if TOK_DEBUG
# define dprintf(f,s) fprintf(stderr, (f), yylineno, (s))
# define amu_return(v)
#else
# define dprintf(f,s)
# define amu_return(v) return((v))
#endif /* TOK_DEBUG */

/* no need to use yyunput() or yywrap() */
#define YY_NO_UNPUT
#define YY_SKIP_YYWRAP

char yytext[YYLMAX];
int yyback(int *yyp, int yym);
# if YYHSIZE
int yyhlook(int yyc, int yyv);
int yymlook(int yyc);
# endif /*YYHSIZE*/
# if YYXSIZE
int yyxlook (int yyc, int yyv);
#endif /*YYXSIZE*/
int yywinput();
void yywoutput(int yyc);
void yywunput(int yyc);
int yywreturn(int yyr);
int yyinput();
void yyoutput(int yyc);
void yyunput(int yyc);
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
int yymbinput();
void yymboutput(int yyc);
void yymbunput(int yyc);
int yymbreturn(int yyx);
#ifdef __cplusplus
}
#endif /* __cplusplus */
# define YYNEWLINE 10
#ifdef __cplusplus
extern "C"
#endif /*__cplusplus */
int yylex(){
int yynstr; extern int yyprevious;
if (__once_yylex) {
      yysetlocale();
#if !(__cplusplus && _CPP_IOSTREAMS)
      if (yyin == NULL) yyin = stdin;
      if (yyout == NULL) yyout = stdout;
#endif /* !(__cplusplus && _CPP_IOSTREAMS) */
      __once_yylex = 0; }
if(yymbcurmax<=0) yymbcurmax=MB_CUR_MAX;
while((yynstr = yylook()) >= 0)
yyfussy: switch(yynstr){
case 0:
if(yywrap()) return(0); break;
case 1:
		{
			yylineno++;
			amu_return(NEWLINE);
			}
/*NOTREACHED*/ break;
case 2:
		{
			dprintf("%8d: Left bracket \"%s\"\n", yytext);
			yylval.strtype = strdup((char *)yytext);
			amu_return(LEFT_BRACKET);
			}
/*NOTREACHED*/ break;
case 3:
		{
			dprintf("%8d: Right bracket \"%s\"\n", yytext);
			yylval.strtype = strdup((char *)yytext);
			amu_return(RIGHT_BRACKET);
			}
/*NOTREACHED*/ break;
case 4:
		{
			dprintf("%8d: Equal \"%s\"\n", yytext);
			yylval.strtype = strdup((char *)yytext);
			amu_return(EQUAL);
			}
/*NOTREACHED*/ break;
case 5:
		{
			dprintf("%8d: Whitespace \"%s\"\n", yytext);
			}
/*NOTREACHED*/ break;
case 6:
	{
			/* a comment line includes the terminating \n */
			yylineno++;
			yytext[strlen((char *)yytext)-1] = '\0';
			dprintf("%8d: Comment \"%s\"\n", yytext);
			}
/*NOTREACHED*/ break;
case 7:
{
			dprintf("%8d: Non-WS string \"%s\"\n", yytext);
			yylval.strtype = strdup((char *)yytext);
			amu_return(NONWS_STRING);
			}
/*NOTREACHED*/ break;
case 8:
{
			dprintf("%8d: QUOTED-Non-WS-EQ string \"%s\"\n", yytext);
			/* must strip quotes */
			yytext[strlen((char *)yytext)-1] = '\0';
			yylval.strtype = strdup((char *)&yytext[1]);
			amu_return(QUOTED_NONWSEQ_STRING);
			}
/*NOTREACHED*/ break;
case 9:
{
			dprintf("%8d: Non-WS-EQ string \"%s\"\n", yytext);
			yylval.strtype = strdup((char *)yytext);
			amu_return(NONWSEQ_STRING);
			}
/*NOTREACHED*/ break;
case -1:
break;
default:
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
(*yyout) << "bad switch yylook " << yynstr;
#else
fprintf(yyout,"bad switch yylook %d",yynstr);
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS)*/
} return(0); }
/* end of yylex */

/*
 * some systems such as DU-4.x have a different GNU flex in /usr/bin
 * which automatically generates yywrap macros and symbols.  So I must
 * distinguish between them and when yywrap is actually needed.
 */
#ifndef yywrap
int yywrap(void)
{
  return 1;
}
#endif /* not yywrap */
int yyvstop[] = {
0,

5,
0,

5,
0,

7,
9,
0,

5,
0,

1,
0,

7,
9,
0,

7,
9,
0,

4,
9,
0,

2,
0,

3,
0,

9,
0,

7,
9,
0,

9,
0,

6,
0,

9,
0,

7,
8,
9,
0,

8,
0,

8,
9,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
	0,0,	0,0,	1,3,	0,0,
	0,0,	0,0,	0,0,	3,3,
	0,0,	13,13,	1,4,	1,5,
	6,12,	14,14,	7,7,	3,0,
	3,0,	8,11,	4,4,	15,15,
	6,13,	6,13,	7,15,	7,16,
	11,11,	8,0,	8,0,	17,17,
	18,0,	18,0,	0,0,	0,0,
	11,0,	11,0,	0,0,	1,6,
	1,7,	2,7,	3,0,	12,18,
	3,3,	4,4,	13,19,	0,0,
	0,0,	6,3,	14,20,	7,7,
	8,0,	0,0,	8,11,	18,0,
	15,15,	0,0,	0,0,	11,0,
	20,11,	11,11,	0,0,	0,0,
	17,17,	0,0,	1,8,	0,0,
	20,0,	20,0,	0,0,	3,11,
	0,0,	13,13,	0,0,	0,0,
	6,14,	0,0,	7,17,	0,0,
	0,0,	0,0,	0,0,	15,15,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	20,0,
	0,0,	20,11,	0,0,	0,0,
	1,9,	0,0,	1,10,	2,10,
	0,0,	3,0,	0,0,	3,0,
	0,0,	0,0,	6,13,	0,0,
	7,15,	0,0,	0,0,	8,0,
	0,0,	8,0,	18,0,	0,0,
	18,0,	0,0,	11,0,	0,0,
	11,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	0,0,	0,0,
	0,0,	0,0,	20,0,	0,0,
	20,0,	0,0};
# define YYHSIZE 0
struct yywwork { wchar_t wch; unsigned int wnext; YYTYPE wverify, wadvance;} yywcrank[] = {
	0,0,0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		yyvstop+1,
yycrank+-2,	yysvec+1,	yyvstop+3,
yycrank+-6,	0,		yyvstop+5,
yycrank+9,	0,		yyvstop+8,
yycrank+0,	0,		yyvstop+10,
yycrank+-11,	0,		yyvstop+12,
yycrank+-13,	0,		yyvstop+15,
yycrank+-16,	yysvec+3,	yyvstop+18,
yycrank+0,	0,		yyvstop+21,
yycrank+0,	0,		yyvstop+23,
yycrank+-23,	yysvec+3,	yyvstop+25,
yycrank+-5,	yysvec+6,	yyvstop+27,
yycrank+-8,	yysvec+6,	0,	
yycrank+-12,	yysvec+6,	yyvstop+30,
yycrank+-18,	yysvec+7,	0,	
yycrank+0,	0,		yyvstop+32,
yycrank+-26,	yysvec+7,	yyvstop+34,
yycrank+-19,	yysvec+3,	yyvstop+36,
yycrank+0,	0,		yyvstop+40,
yycrank+-55,	yysvec+3,	yyvstop+42,
0,	0,	0};
struct yywork *yytop = yycrank+148;
struct yysvf *yybgin = yysvec+1;
unsigned char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,'"' ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,'=' ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,'[' ,01  ,'[' ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
0};
unsigned char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/* @(#)44 1.9.2.5 src/bos/usr/ccs/lib/libl/ncform, libl, bos43D, 9803A_43D 1/12/98 17:52:31";*/
/*
 * COMPONENT_NAME: (LIBL) Lex Libraries
 *
 * FUNCTIONS: yylook, yyhlook, yyback, yyinput, yyoutput, yyunput,
 *            yymbinput, yymboutput, yymbunput, yymbreturn
 *            yywinput, yywoutput, yywunput, yywreturn
 *
 * ORIGINS: 3
 *
*/

int yylineno =1;

# define YYU(x)         x
# define NLSTATE        yyprevious=YYNEWLINE

# define YYCCLDOT       0x0001

wchar_t         yywtext[YYLMAX];
wchar_t         yywbuf[YYLMAX];

unsigned char   yytbuf[YYLMAX];
unsigned char   *yytbp;
int             yytbi;
wchar_t         yytwc;

struct yysvf    *yylstate [YYLMAX], **yylsp, **yyolsp;
unsigned char   yysbuf[YYLMAX];
unsigned char   *yysptr = yysbuf;
int             *yyfnd;
extern struct yysvf *yyestate;
int             yyprevious = YYNEWLINE;

# ifdef LEXDEBUG
int             debug;
#ifdef __cplusplus
#ifdef _CPP_IOSTREAMS
void            allprint(wchar_t);
void            sprint  (wchar_t *);
#else
extern "C" void allprint(wchar_t);
extern "C" void sprint  (wchar_t *);
#endif
#endif
# endif

yylook()
{
register struct yysvf *yystate, **yytlsp;
register struct yywork *yyt;
struct yysvf    *yyz;
int             yywch, yyfirst, yyw;
struct yywork   *yyr;
wchar_t         *yywlastch;
/*
 * start off machines
 */
# ifdef LEXDEBUG
    debug = 1;
# endif

    yyfirst=1;
    if (!yymorfg)
        yywlastch = yywtext;
    else
    {
        yymorfg=0;
        yywlastch = &(yywtext[yywleng]);
    }

    for(;;)
    {
        yytlsp = yylstate;
        yyestate = yystate = yybgin;
        if (yyprevious==YYNEWLINE)
            yystate++;
        for (;;)
        {
# ifdef LEXDEBUG
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
            if(debug) (*yyout) << "state " << yystate-yysvec-1 << endl;
#else
            if(debug) fprintf(yyout,"state %d\n",yystate-yysvec-1);
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# endif
            yyt = yystate->yystoff;
            if(yyt == yycrank && !yyfirst)      /* may not be any transitions */
            {
                yyz = yystate->yyother;
                if(yyz == 0)
                    break;
                if(yyz->yystoff == yycrank)
                    break;
            }
            yywch = winput();

           if( (yywlastch - yywtext) < YYLMAX -1)
            *yywlastch++ = yywch;

           else
           {
            fprintf(yyout,"LEX Error: input string too long to fit in yywtext[].\n\
            Increase the array size by defining YYLMAX to be a higher value\n");

            exit(1);

           }


            yyfirst=0;
        tryagain:
# ifdef LEXDEBUG
            if(debug)
            {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                (*yyout) << "char ";
                allprint (yywch);
                (*yyout) << endl;
#else
                fprintf(yyout,"char ");
                allprint(yywch);
                putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
            }
# endif
            yyr = yyt;
            if ( (long)yyt > (long)yycrank)
            {
                if (yywch < NCH)                /* 8-bit */
                {
                    yyt = yyr + yywch;
                    if (yyt <= yytop && yyt->verify+yysvec == yystate)
                    {
                        if(yyt->advance+yysvec == YYLERR) /* error transitions */
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yyt->advance+yysvec;
                        goto contin;
                    }
                }
# if YYHSIZE
                else                            /* wide */
                {
                    if (yyw = yyhlook(yywch,yystate-yysvec))
                    {
                        if (yywcrank[yyw].wadvance+yysvec==YYLERR)
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yywcrank[yyw].wadvance+yysvec;
                        goto contin;
                    }
                }
# endif /*YYHSIZE*/
            }
# ifdef YYOPTIM
            else if ((long)yyt < (long)yycrank)   /* r < yycrank */
            {
                yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                if(debug) (*yyout) << "compressed state" << endl;
#else
                if(debug) fprintf(yyout,"compressed state\n");
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# endif
                if (yywch < NCH)                /* 8-bit */
                {
                    yyt = yyt + yywch;
                    if(yyt <= yytop && yyt->verify+yysvec == yystate)
                    {
                        if(yyt->advance+yysvec == YYLERR) /* error transitions */
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yyt->advance+yysvec;
                        goto contin;
                    }
                    yyt = yyr + YYU(yymatch[yywch]);
# ifdef LEXDEBUG
                    if(debug)
                    {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                        (*yyout) << "try fall back character ";
                        allprint(YYU(yymatch[yywch]));
                        (*yyout) << endl;
#else
                        fprintf(yyout,"try fall back character ");
                        allprint(YYU(yymatch[yywch]));
                        putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                    }
# endif
                    if(yyt <= yytop && yyt->verify+yysvec == yystate)
                    {
                        if(yyt->advance+yysvec == YYLERR) /* error transition */
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yyt->advance+yysvec;
                        goto contin;
                    }
                }
# if YYHSIZE
                else                            /* wide */
                {
                    if (yyw = yyhlook(yywch,yystate-yysvec))
                    {
                        if (yywcrank[yyw].wadvance+yysvec==YYLERR)
                        {
                            wunput(*--yywlastch);
                            break;
                        }
                        *yytlsp++ = yystate = yywcrank[yyw].wadvance+yysvec;
                        goto contin;
                    }
                    if (yyw = yymlook(yywch))   /* find the target char */
                    {
                        if (yyw = yyhlook(yyw,yystate-yysvec))
                        {
                            if (yywcrank[yyw].wadvance+yysvec == YYLERR)
                            {
                                wunput(*--yywlastch);
                                break;
                            }
                            *yytlsp++ = yystate = yywcrank[yyw].wadvance+yysvec;
                            goto contin;
                        }
                    }
                }
# endif /*YYHSIZE*/
# if YYXSIZE
# ifdef MFDEBUG
                if (debug)
                {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                    (*yyout) << "try extended ccl on char ";
                    allprint(YYU(yywch));
                    (*yyout) << '\n';
#else
                    fprintf (yyout, "try extended ccl on char ");
                    allprint(YYU(yywch));
                    putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                }
# endif
                yyw = yyxlook(yywch,yystate-yysvec);
                if (yyw != -1)
                {
                    if (yyxccl[yyw].advance+yysvec == YYLERR)
                    {
                        wunput(*--yywlastch);
                        break;
                    }
                    *yytlsp++ = yystate = yyxccl[yyw].advance+yysvec;
                    goto contin;
                }
# endif /*YYXSIZE*/
            } /* r < yycrank */
            if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank)
            {
# ifdef LEXDEBUG
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                if(debug) (*yyout) << "fall back to state "
                                   << yystate-yysvec-1 << endl;
#else
                if(debug) fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# endif
                goto tryagain;
            }
# endif /*YYOPTIM*/
            else
            {
                wunput(*--yywlastch);
                break;
            }
        contin:
# ifdef LEXDEBUG
            if(debug)
            {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                (*yyout) << "state " << yystate-yysvec-1 << " char ";
                allprint(yywch);
                (*yyout) << endl;
#else
                fprintf(yyout,"state %d char ",yystate-yysvec-1);
                allprint(yywch);
                putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
            }
# endif
            ; /* contin: */
        } /* for(;;) */
# ifdef LEXDEBUG
        if(debug)
        {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
            (*yyout) << "stopped at " << (int) (*(yytlsp-1)-yysvec-1) << " with ";
            allprint(yywch);
            (*yyout) << endl;
#else
            fprintf(yyout,"stopped at %d with ",*(yytlsp-1)-yysvec-1);
            allprint(yywch);
            putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
        }
# endif
        while (yytlsp-- > yylstate)
        {
            *yywlastch-- = 0;
            if (*yytlsp != 0 && (yyfnd= (*yytlsp)->yystops) && *yyfnd > 0)
            {
                yyolsp = yytlsp;
                if(yyextra[*yyfnd])             /* must backup */
                {
                    while(yyback((*yytlsp)->yystops,-*yyfnd) != 1 && yytlsp > yylstate)
                    {
                        yytlsp--;
                        wunput(*yywlastch--);
                    }
                }
                yyprevious = YYU(*yywlastch);
                yylsp = yytlsp;
                yywleng = yywlastch-yywtext+1;
                yywtext[yywleng] = 0;
# ifdef LEXDEBUG
                if(debug)
                {
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                    (*yyout) << "\nmatch ";
                    sprint(yywtext);
                    (*yyout) << " action " << *yyfnd << endl;
#else
                    fprintf(yyout,"\nmatch ");
                    sprint(yywtext);
                    fprintf(yyout," action %d\n",*yyfnd);
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                }
# endif

                wreturn(*yyfnd++);
            }
            wunput(*yywlastch);
        }
        if (yywtext[0] == 0  /* && feof(yyin) */)
        {
            yysptr=yysbuf;
            wreturn(0);
        }
        yyprevious = yywtext[0] = winput();
        if (yyprevious>0)
            woutput(yyprevious);
        yywlastch=yywtext;
# ifdef LEXDEBUG
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
        if(debug) cout << endl;
#else
        if(debug) putchar('\n');
#endif /* #if defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
# endif
    } /* for (;;) */
    wreturn(0);
}
int yyback(int *yyp, int yym)
{
    if (yyp==0) return(0);
    while (*yyp)
    {
        if (*yyp++ == yym)
            return(1);
    }
    return(0);
}
# if YYHSIZE
/*
 * wide chars are hashed in yywcrank, return the index of the found element, or
 * zero
 */
int yyhlook(int yyc, int yyv)
{
int             yyn;

    yyn = (yyc % (YYHSIZE - 1)) + 1;
    for (;;)
    {
        if ((yywcrank[yyn].wch==yyc)&&(yywcrank[yyn].wverify==yyv))
            return(yyn);
        yyn = yywcrank[yyn].wnext;
        if (yyn==0)
            return(0);
    }
}
# endif /*YYHSIZE*/
# if YYHSIZE
/*
 * wide CCL chars are hashed in yywmatch, return the character to map to or
 * zero if there are none;  each char occurs only once in the match table.
 */
int
yymlook(int yyc)
{
# if YYMSIZE
int             yyn;

    yyn = (yyc % (YYMSIZE - 1)) + 1;

    while (yyn!=0)
    {
        if (yywmatch[yyn].wch == yyc)
            return(yywmatch[yyn].wmatch);
        yyn = yywmatch[yyn].wnext;
    }
# endif /*YYMSIZE*/

    return(0);
}
# endif /*YYHSIZE*/
# if YYXSIZE
/*
 * general CCLs are described in yyxccl; return the index of the first
 * acceptable CCL that matches verification, -1 if none found.
 */
int
yyxlook (int yyc, int yyv)
{
register int yyi;

    if (!yyc)                                     /* c==0 => EOF */
        return (-1);

    for (yyi = 0; (yyi < YYXSIZE) && (yyxccl[yyi].verify < yyv); yyi++)
        ; /*Empty*/

    for ( ; (yyi < YYXSIZE) && (yyxccl[yyi].verify == yyv); yyi++)
    {
        switch (yyxccl[yyi].type)
        {
        case YYCCLDOT:  return((yyc=='\n')?-1:yyi);
        }
    }
    return (-1);
}
#endif
/*
 * The following are the multi-byte renditions of input, unput, and
 * output.  They are referenced through the winput, wunput, and woutput macros
 * resepectively.
 *
 * A (-1) is returned if the character input is invalid.
 */
#ifdef __cplusplus
#include <mbstr.h>
#endif /*  __cplusplus */
int yywinput()
{
    yytbi=0;
    do
    {
        yytbuf[yytbi++]=input();
        yytbuf[yytbi]=0;
    } while(mbsinvalid((const char *) yytbuf)&&(yytbi<yymbcurmax));

    if (mbtowc(&yytwc,(const char *)yytbuf,yymbcurmax)<0)
        return (-1);

    return ((int)yytwc);
}

void yywoutput(int yyc)
{
    for (yytbi=wctomb((char *) yytbuf,(wchar_t)yyc),yytbp=yytbuf;yytbi>0;yytbi--)
        output(*yytbp++);
}
void yywunput(int yyc)
{
    for(yytbi=wctomb((char *)yytbuf,(wchar_t)yyc)-1;yytbi>=0;yytbi--)
        unput(yytbuf[yytbi]);
}
/*
 * Convert yywtext to yytext prior to returning from yylook.  It is referenced
 * through the wreturn macro.
 */
int yywreturn(int yyr)
{
    yyleng=wcstombs((char *)yytext,yywtext,YYLMAX);
    if(yyleng<0)
    {
        yyleng=0;
        yytext[0]=0;
    }
    return(yyr);
}
/*
 * the following are only used in the lex library
 */
int yyinput()
{
    return(input());
}
void yyoutput(int yyc)
{
    output(yyc);
}
void yyunput(int yyc)
{
    unput(yyc);
}
int yymbinput()
{
    return(winput());
}
void yymboutput(int yyc)
{
    woutput(yyc);
}
void yymbunput(int yyc)
{
    wunput(yyc);
}
int yymbreturn(int yyx)
{
    wreturn (yyx);
}
